#ifndef _LIVEPATCH_BSC1099258_H
#define _LIVEPATCH_BSC1099258_H

#if IS_ENABLED(CONFIG_X86_64) && IS_ENABLED(CONFIG_KVM)

int livepatch_bsc1099258_init(void);
void livepatch_bsc1099258_cleanup(void);


struct kvm_vcpu;

int klp_handle_vmon(struct kvm_vcpu *vcpu);
int klp_handle_vmoff(struct kvm_vcpu *vcpu);
int klp_handle_vmclear(struct kvm_vcpu *vcpu);
int klp_handle_vmread(struct kvm_vcpu *vcpu);
int klp_handle_vmwrite(struct kvm_vcpu *vcpu);
int klp_handle_vmptrld(struct kvm_vcpu *vcpu);
int klp_handle_vmptrst(struct kvm_vcpu *vcpu);
int klp_handle_invept(struct kvm_vcpu *vcpu);
int klp_handle_invvpid(struct kvm_vcpu *vcpu);

#else /* !(IS_ENABLED(CONFIG_X86_64) && IS_ENABLED(CONFIG_KVM)) */

static inline int livepatch_bsc1099258_init(void) { return 0; }
static inline void livepatch_bsc1099258_cleanup(void) {}

#endif /* IS_ENABLED(CONFIG_X86_64) && IS_ENABLED(CONFIG_KVM) */

#endif /* _LIVEPATCH_BSC1099258 */
